using System;
using System.Collections.Generic;
using System.Linq;
using Base;

namespace EnhancerEvaluation
{
    public class Args
    {
        public Args(string[] args)
        {
            int temp;
            StringArgs = new CheckLookupDictionary<string, string>(
                args.Select((x, i) => new {Arg = x, ValueIndex = i + 1})
                    .Where(x => 
                           (x.Arg[0] == '-') && 
                           x.ValueIndex < args.Length &&
                           args[x.ValueIndex][0] != '-' && 
                           !int.TryParse(args[x.ValueIndex], out temp))
                    .Select(x => new { Arg = x.Arg, Value = args[x.ValueIndex] })
                    .ToDictionary(x => x.Arg.Substring(1), x => x.Value));
            
            IntArgs = new CheckLookupDictionary<string, int>(
                args.Select((x, i) => new {Arg = x, ValueIndex = i + 1})
                    .Where(x => 
                           (x.Arg[0] == '-') && 
                           x.ValueIndex < args.Length &&
                           args[x.ValueIndex][0] != '-' && 
                           int.TryParse(args[x.ValueIndex], out temp))
                    .Select(x => new { Arg = x.Arg, Value = int.Parse(args[x.ValueIndex]) })
                    .ToDictionary(x => x.Arg.Substring(1), x => x.Value));
            
            Flags = new HashSet<string>(
                args.Select((x, i) => new {Arg = x, ValueIndex = i + 1})
                .Where(x => 
                   (x.Arg[0] == '-') && 
                   (x.ValueIndex >= args.Length ||
             args[x.ValueIndex][0] == '-'))
                .Select(x => x.Arg.Substring(1)));
        }

		public CheckLookupDictionary<string, string> StringArgs { get; set; }
		public CheckLookupDictionary<string, int> IntArgs { get; set; }
        public HashSet<string> Flags { get; set; }
    }
}

